%define anolis_release 2
Summary: DWARF optimization and duplicate removal tool
Name: dwz
Url: https://sourceware.org/dwz/
Version: 0.14
Release: %{anolis_release}%{?dist}
License: GPLv2+ and GPLv3+
Source: https://sourceware.org/ftp/dwz/releases/%{name}-%{version}.tar.xz
# backport from upstream to fix odr-struct-multifile.sh fained
Patch1: 0001-testsuite-Handle-readelf-following-links-by-default.patch
BuildRequires: gcc, gcc-c++, gdb, elfutils-libelf-devel, dejagnu
BuildRequires: make

%description
The dwz package contains a program that attempts to optimize DWARF
debugging information contained in ELF shared libraries and ELF executables
for size, by replacing DWARF information representation with equivalent
smaller representation where possible and by reducing the amount of
duplication using techniques from DWARF standard appendix E - creating
DW_TAG_partial_unit compilation units (CUs) for duplicated information
and using DW_TAG_imported_unit to import it into each CU that needs it.

%prep
%autosetup -p1 -n dwz

%build
%make_build CFLAGS='%{optflags}' LDFLAGS='%{build_ldflags}' \
  prefix=%{_prefix} mandir=%{_mandir} bindir=%{_bindir}

%install
rm -rf %{buildroot}
%make_install prefix=%{_prefix} mandir=%{_mandir} bindir=%{_bindir}

%generate_compatibility_deps

%check
make check

%files
%dir %{abidir}
%license COPYING COPYING3 COPYING.RUNTIME
%{_bindir}/dwz
%{abidir}/dwz-option.list
%{_mandir}/man1/dwz.1*

%changelog
* Mon Oct 31 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.14-2
- optimise spec file

* Mon Apr 18 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 0.14-1
- init from upstream
- fix failed test:odr-struct-multifile.sh
